<template>
  <div class="container">
    <div class="card">
      <div class="card-header">
        Post by {{ author }} on {{ dateCreated }}
      </div>
      <div class="card-body">
        <h5 class="card-title">{{ title }}</h5>
        <p class="card-text">{{ postSynopsis }}</p><p> <a href="#">[read more]</a></p>
        <base-button button-type="edit-button" v-if="userIsAuthenticated">Edit</base-button>
      </div>
      <div class="card-footer text-muted">
        likes: {{ numLikes }}, comments: {{ numComments }}
      </div>
    </div></div>
</template>

<script>
export default {
  name: "PostShort",
  props: ['id', 'title', 'author', 'dateCreated', 'body', 'numLikes', 'numComments'],
  computed: {
    postSynopsis() {
      // returns shorter of first sentence & 140 chars.
      let synopsis = this.body.slice(0, 140);
      let c = synopsis.slice(-1);
      while (c !== '.' && synopsis.length > 0) {
        synopsis = synopsis.slice(0, synopsis.length - 1);
        c = synopsis.slice(-1);
      }
      return synopsis;
    },
    userIsAuthenticated() {
      return this.$store.getters['auth/getUserIsAuthenticated'];
    },
  },
}
</script>

<style scoped>
.container {
  margin-bottom: 25px;
}

</style>
